/*
	Vector2D - v. 1.0
	--------------------------------------------------------------------------------------
	This 2D vector object was created by Johannes Hansen 2003
	You may use it any way you want to as long as you don't delete this comment.
	If you have any suggestions to this object, email them to admin@scriptcentral.dk.
	The subject of the email should be "Vector2D".
	
	Enjoy! ;)
*/

Vector2D =
function (x, y) {
	this.x = x;
	this.y = y;
}

Vector2D.prototype.Length =
Vector2D.prototype.Magnitude =
Vector2D.prototype.Modulus =
function () {
	return Math.sqrt(this.x * this.x + this.y * this.y);
}

Vector2D.prototype.Angle =
function () {
	return Math.atan2(this.y, this.x) / Math.PI * 180;
}

Vector2D.prototype.Dot =
Vector2D.prototype.DotProduct =
Vector2D.prototype.ScalarProduct =
function (vector) {
	return this.x * vector.x + this.y * vector.y;
}

Vector2D.prototype.Add =
function (vector) {
	this.x += vector.x;
	this.y += vector.y;
	//added birdy1976
	return new Vector2D(this.x, this.y);
}

Vector2D.prototype.Subtract =
function (vector) {
	this.x -= vector.x;
	this.y -= vector.y;
	//added birdy1976
	return new Vector2D(this.x, this.y);
}

Vector2D.prototype.Scale =
function (scale) {
	this.x *= scale;
	this.y *= scale;
	//added birdy1976
	return new Vector2D(this.x, this.y);
}

Vector2D.prototype.Normalize =
function () {
	var m = this.Modulus();
	if (m > 0) {
		this.x /= m;
		this.y /= m;
	}
	//added birdy1976
	return new Vector2D(this.x, this.y);
}

Vector2D.prototype.Rotate =
function (angle) {
	var m = this.Modulus();
	var cA = Math.atan2(this.y, this.x);
	this.x = Math.cos(cA + angle * Math.PI / 180) * m;
	this.y = Math.sin(cA + angle * Math.PI / 180) * m;
	//added birdy1976
	return new Vector2D(this.x, this.y);
}

Vector2D.prototype.Copy =
function () {
	return new Vector2D(this.x, this.y);
}